diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index f379d25e..0d8a8175 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -89,7 +89,7 @@ public class TwistyMirror extends Twisty6
   public TwistyMirror(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                       DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.MIRR, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -629,6 +629,19 @@ public class TwistyMirror extends Twisty6
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    switch(numLayers)
+      {
+      case 2: return ObjectList.MIRR_2;
+      case 3: return ObjectList.MIRR_3;
+      }
+
+    return ObjectList.MIRR_2;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
index 28f59e26..5581fc2a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
@@ -68,7 +68,7 @@ public class TwistyPyraminx extends Twisty4
   public TwistyPyraminx(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                         DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.PYRA, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -420,6 +420,20 @@ public class TwistyPyraminx extends Twisty4
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    switch(numLayers)
+      {
+      case 3: return ObjectList.PYRA_3;
+      case 4: return ObjectList.PYRA_4;
+      case 5: return ObjectList.PYRA_5;
+      }
+
+    return ObjectList.PYRA_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
index f6af9bac..97174ea4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
@@ -75,7 +75,7 @@ public class TwistyRedi extends Twisty6
   public TwistyRedi(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                     DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.REDI, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -453,6 +453,13 @@ public class TwistyRedi extends Twisty6
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.REDI_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
index 48ca09f7..d0c68890 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
@@ -76,7 +76,7 @@ public class TwistyRex extends Twisty6
   public TwistyRex(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                    DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.REX, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -486,6 +486,13 @@ public class TwistyRex extends Twisty6
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.REX_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
index 223eac94..f61dae20 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
@@ -74,7 +74,7 @@ public class TwistySkewb extends Twisty6
   public TwistySkewb(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                      DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, 2*size-2, quat, texture, mesh, effects, moves, ObjectList.SKEW, res, scrWidth);
+    super(size, 2*size-2, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -595,6 +595,19 @@ public class TwistySkewb extends Twisty6
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    switch(numLayers)
+      {
+      case 2: return ObjectList.SKEW_2;
+      case 3: return ObjectList.SKEW_3;
+      }
+
+    return ObjectList.SKEW_2;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
index 70fc663c..4c400c0f 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
@@ -66,9 +66,9 @@ abstract class TwistySquare extends Twisty6
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   TwistySquare(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-               DistortedEffects effects, int[][] moves, ObjectList obj, Resources res, int scrWidth)
+               DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, obj, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
index e5d3b893..a66cab6e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
@@ -50,7 +50,7 @@ public class TwistySquare1 extends TwistySquare
   public TwistySquare1(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                        DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.SQU1, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -350,6 +350,13 @@ public class TwistySquare1 extends TwistySquare
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.SQU1_3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
   public int getObjectName(int numLayers)
     {
     return R.string.squa1;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
index 26f84f73..6bb9a28e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
@@ -50,7 +50,7 @@ public class TwistySquare2 extends TwistySquare
   public TwistySquare2(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                        DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.SQU2, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -383,6 +383,13 @@ public class TwistySquare2 extends TwistySquare
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.SQU2_3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
   public int getObjectName(int numLayers)
     {
     return R.string.squa2;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
index 5d197dd3..bf1420ce 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
@@ -79,7 +79,7 @@ public class TwistyUltimate extends Twisty12
   public TwistyUltimate(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                         DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.ULTI, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -441,6 +441,13 @@ public class TwistyUltimate extends Twisty12
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.ULTI_2;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
